## mingw-w64-gnuradio-3.10.12.0-3.src.tar.zst

=== gr-fec/lib/CMakeLists.txt ===
# Copyright 2012-2014,2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

# These are convenience libraries of 3rd party code.
# Change to test for distro provided packages

########################################################################
# Setup library
########################################################################
add_library(
    gnuradio-fec
    generic_decoder.cc
    generic_encoder.cc
    decoder_impl.cc
    encoder_impl.cc
    tagged_decoder_impl.cc
    tagged_encoder_impl.cc
    async_decoder_impl.cc
    async_encoder_impl.cc
    cc_decoder_impl.cc
    cc_encoder_impl.cc
    ccsds_encoder_impl.cc
    dummy_decoder_impl.cc
    dummy_encoder_impl.cc
    repetition_decoder_impl.cc
    repetition_encoder_impl.cc
    decode_ccsds_27_fb_impl.cc
    encode_ccsds_27_bb_impl.cc
    ber_bf_impl.cc
    conv_bit_corr_bb_impl.cc
    puncture_bb_impl.cc
    puncture_ff_impl.cc
    depuncture_bb_impl.cc
    ldpc_encoder_impl.cc
    ldpc_decoder.cc
    cldpc.cc
    awgn_bp.cc
    gf2vec.cc
    gf2mat.cc
    alist.cc
    tpc_common.cc
    tpc_decoder.cc
    tpc_encoder.cc
    polar_encoder.cc
    polar_decoder_sc.cc
    polar_common.cc
    polar_decoder_sc_list.cc
    polar_decoder_common.cc
    scl_list.cc
    polar_encoder_systematic.cc
    polar_decoder_sc_systematic.cc)
target_include_directories(
    gnuradio-fec PUBLIC $<INSTALL_INTERFACE:include>
                        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

add_subdirectory(reed-solomon)

target_sources(
    gnuradio-fec
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/viterbi/metrics.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/viterbi/tab.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/viterbi/viterbi.cc)

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-fec.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fec.rc @ONLY)

    target_sources(gnuradio-fec PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fec.rc)
endif(MSVC)

target_link_libraries(gnuradio-fec PUBLIC gnuradio-runtime gnuradio-blocks)

if(ENABLE_COMMON_PCH)
    target_link_libraries(gnuradio-fec PRIVATE common-precompiled-headers)
endif()

# Address linker issues with std::filesystem on Centos 8 and Debian
target_link_libraries(
    gnuradio-fec
    PRIVATE
        $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
)

# Only include the LDPC work if we have GSL installed
if(GSL_FOUND)
    target_link_libraries(gnuradio-fec PRIVATE GSL::gsl)
    target_sources(
        gnuradio-fec
        PRIVATE ldpc_bit_flip_decoder_impl.cc ldpc_par_mtrx_encoder_impl.cc
                ldpc_gen_mtrx_encoder_impl.cc ldpc_H_matrix_impl.cc ldpc_G_matrix_impl.cc
                fec_mtrx_impl.cc)
endif(GSL_FOUND)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-fec)
endif()

=== gr-blocks/python/blocks/bindings/CMakeLists.txt ===
# Copyright 2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPybind)

########################################################################
# Python Bindings
########################################################################
list(
    APPEND
    blocks_python_files
    abs_blk_python.cc
    add_blk_python.cc
    add_const_bb_python.cc
    add_const_cc_python.cc
    add_const_ff_python.cc
    add_const_ii_python.cc
    add_const_ss_python.cc
    add_const_v_python.cc
    and_blk_python.cc
    and_const_python.cc
    annotator_1to1_python.cc
    annotator_alltoall_python.cc
    annotator_raw_python.cc
    argmax_python.cc
    blockinterleaver_xx_python.cc
    burst_tagger_python.cc
    burst_to_stream_python.cc
    char_to_float_python.cc
    char_to_short_python.cc
    check_lfsr_32k_s_python.cc
    complex_to_arg_python.cc
    complex_to_float_python.cc
    complex_to_imag_python.cc
    complex_to_interleaved_char_python.cc
    complex_to_interleaved_short_python.cc
    complex_to_mag_python.cc
    complex_to_mag_squared_python.cc
    complex_to_magphase_python.cc
    complex_to_real_python.cc
    conjugate_cc_python.cc
    control_loop_python.cc
    copy_python.cc
    correctiq_python.cc
    correctiq_auto_python.cc
    correctiq_man_python.cc
    correctiq_swapiq_python.cc
    count_bits_python.cc
    deinterleave_python.cc
    delay_python.cc
    divide_python.cc
    endian_swap_python.cc
    exponentiate_const_cci_python.cc
    file_descriptor_sink_python.cc
    file_descriptor_source_python.cc
    file_meta_sink_python.cc
    file_meta_source_python.cc
    file_sink_python.cc
    file_sink_base_python.cc
    file_source_python.cc
    float_to_char_python.cc
    float_to_complex_python.cc
    float_to_int_python.cc
    float_to_short_python.cc
    float_to_uchar_python.cc
    head_python.cc
    host_buffer_copy_python.cc
    int_to_float_python.cc
    integrate_python.cc
    interleave_python.cc
    interleaved_char_to_complex_python.cc
    interleaved_short_to_complex_python.cc
    keep_m_in_n_python.cc
    keep_one_in_n_python.cc
    lfsr_15_1_0_python.cc
    lfsr_32k_python.cc
    lfsr_32k_source_s_python.cc
    magphase_to_complex_python.cc
    max_blk_python.cc
    message_debug_python.cc
    message_strobe_python.cc
    message_strobe_random_python.cc
    min_blk_python.cc
    moving_average_python.cc
    multiply_python.cc
    multiply_by_tag_value_cc_python.cc
    multiply_conjugate_cc_python.cc
    multiply_const_python.cc
    multiply_const_v_python.cc
    multiply_matrix_python.cc
    mute_python.cc
    nlog10_ff_python.cc
    nop_python.cc
    not_blk_python.cc
    null_sink_python.cc
    null_source_python.cc
    or_blk_python.cc
    # pack_k_bits_python.cc
    pack_k_bits_bb_python.cc
    packed_to_unpacked_python.cc
    patterned_interleaver_python.cc
    peak_detector_python.cc
    peak_detector2_fb_python.cc
    phase_shift_python.cc
    plateau_detector_fb_python.cc
    probe_rate_python.cc
    probe_signal_python.cc
    probe_signal_v_python.cc
    regenerate_bb_python.cc
    repack_bits_bb_python.cc
    repeat_python.cc
    rms_cf_python.cc
    rms_ff_python.cc
    rotator_python.cc
    rotator_cc_python.cc
    sample_and_hold_python.cc
    selector_python.cc
    short_to_char_python.cc
    short_to_float_python.cc
    skiphead_python.cc
    stream_demux_python.cc
    stream_mux_python.cc
    stream_to_streams_python.cc
    stream_to_tagged_stream_python.cc
    stream_to_vector_python.cc
    streams_to_stream_python.cc
    streams_to_vector_python.cc
    stretch_ff_python.cc
    sub_python.cc
    tag_debug_python.cc
    tag_gate_python.cc
    tag_share_python.cc
    tagged_file_sink_python.cc
    tagged_stream_align_python.cc
    tagged_stream_multiply_length_python.cc
    tagged_stream_mux_python.cc
    tags_strobe_python.cc
    test_tag_variable_rate_ff_python.cc
    threshold_ff_python.cc
    throttle_python.cc
    transcendental_python.cc
    tsb_vector_sink_python.cc
    uchar_to_float_python.cc
    unpack_k_bits_python.cc
    unpack_k_bits_bb_python.cc
    unpacked_to_packed_python.cc
    vco_c_python.cc
    vco_f_python.cc
    vector_insert_python.cc
    vector_map_python.cc
    vector_sink_python.cc
    vector_source_python.cc
    vector_to_stream_python.cc
    vector_to_streams_python.cc
    xor_blk_python.cc
    python_bindings.cc)

if(SNDFILE_FOUND)
    list(APPEND blocks_python_files wavfile_python.cc wavfile_sink_python.cc
         wavfile_source_python.cc)
endif()

if(ENABLE_GR_CTRLPORT)
    list(APPEND blocks_python_files 
        ctrlport_probe2_b_python.cc
        ctrlport_probe2_c_python.cc
        ctrlport_probe2_f_python.cc
        ctrlport_probe2_i_python.cc
        ctrlport_probe2_s_python.cc
        ctrlport_probe_c_python.cc
        )
endif()

gr_pybind_make_check_hash(blocks ../../.. gr::blocks "${blocks_python_files}")

if(ENABLE_GR_CTRLPORT)
    target_compile_definitions(blocks_python PUBLIC GR_HAVE_CTRLPORT)
endif()

install(
    TARGETS blocks_python
    DESTINATION ${GR_PYTHON_DIR}/gnuradio/blocks
    COMPONENT pythonapi)

=== gr-digital/include/gnuradio/digital/CMakeLists.txt ===
# Copyright (C) 2011-2017 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install header files
########################################################################
install(
    FILES adaptive_algorithm.h
          adaptive_algorithm_cma.h
          adaptive_algorithm_lms.h
          adaptive_algorithm_nlms.h
          additive_scrambler.h
          additive_scrambler_bb.h
          api.h
          binary_slicer_fb.h
          burst_shaper.h
          chunks_to_symbols.h
          clock_recovery_mm_cc.h
          clock_recovery_mm_ff.h
          constellation.h
          constellation_decoder_cb.h
          constellation_encoder_bc.h
          constellation_receiver_cb.h
          constellation_soft_decoder_cf.h
          corr_est_cc.h
          correlate_access_code_bb.h
          correlate_access_code_tag_bb.h
          correlate_access_code_tag_ff.h
          correlate_access_code_bb_ts.h
          correlate_access_code_ff_ts.h
          costas_loop_cc.h
          cpmmod_bc.h
          crc.h
          crc16_async_bb.h
          crc32_bb.h
          crc32_async_bb.h
          crc_append.h
          crc_check.h
          decision_feedback_equalizer.h
          descrambler_bb.h
          diff_coding_type.h
          diff_decoder_bb.h
          diff_encoder_bb.h
          diff_phasor_cc.h
          fll_band_edge_cc.h
          framer_sink_1.h
          glfsr.h
          glfsr_source_b.h
          glfsr_source_f.h
          hdlc_deframer_bp.h
          hdlc_framer_pb.h
          header_buffer.h
          header_payload_demux.h
          lfsr.h
          linear_equalizer.h
          map_bb.h
          metric_type.h
          modulate_vector.h
          mpsk_snr_est.h
          mpsk_snr_est_cc.h
          msk_timing_recovery_cc.h
          ofdm_carrier_allocator_cvc.h
          ofdm_chanest_vcvc.h
          ofdm_cyclic_prefixer.h
          ofdm_equalizer_base.h
          ofdm_equalizer_simpledfe.h
          ofdm_equalizer_static.h
          ofdm_frame_equalizer_vcvc.h
          ofdm_serializer_vcc.h
          ofdm_sync_sc_cfb.h
          header_format_base.h
          header_format_default.h
          header_format_counter.h
          header_format_crc.h
          header_format_ofdm.h
          protocol_formatter_async.h
          protocol_formatter_bb.h
          protocol_parser_b.h
          packet_header_default.h
          packet_header_ofdm.h
          packet_headergenerator_bb.h
          packet_headerparser_b.h
          packet_sink.h
          pfb_clock_sync_ccf.h
          pfb_clock_sync_fff.h
          pn_correlator_cc.h
          probe_density_b.h
          probe_mpsk_snr_est_c.h
          scrambler_bb.h
          interpolating_resampler_type.h
          symbol_sync_cc.h
          symbol_sync_ff.h
          timing_error_detector_type.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio/digital)

=== gr-soapy/include/gnuradio/soapy/CMakeLists.txt ===
# Copyright 2011-2021 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-soapy
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install public header files
########################################################################

install(FILES api.h block.h soapy_types.h source.h sink.h
        DESTINATION ${GR_INCLUDE_DIR}/gnuradio/soapy)

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=gnuradio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.10.12.0
pkgrel=3
pkgdesc="General purpose DSP and SDR toolkit (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://gnuradio.org/'
msys2_repository_url="https://github.com/gnuradio/gnuradio"
msys2_references=(
  'archlinux: gnuradio'
)
license=(spdx:GPL-3.0-or-later)
depends=("${MINGW_PACKAGE_PREFIX}-codec2"
  "${MINGW_PACKAGE_PREFIX}-boost-libs"
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-gmp"
  "${MINGW_PACKAGE_PREFIX}-gsl"
  "${MINGW_PACKAGE_PREFIX}-gsm"
  "${MINGW_PACKAGE_PREFIX}-gtk3"
  "${MINGW_PACKAGE_PREFIX}-libad9361-iio"
  "${MINGW_PACKAGE_PREFIX}-libiio"
  "${MINGW_PACKAGE_PREFIX}-libuhd" 
  "${MINGW_PACKAGE_PREFIX}-libunwind"
  "${MINGW_PACKAGE_PREFIX}-fftw"
  "${MINGW_PACKAGE_PREFIX}-mathjax2"
  "${MINGW_PACKAGE_PREFIX}-volk"
  "${MINGW_PACKAGE_PREFIX}-python-click"
  "${MINGW_PACKAGE_PREFIX}-python-click-plugins"
  "${MINGW_PACKAGE_PREFIX}-python-gobject"
  "${MINGW_PACKAGE_PREFIX}-python-cairo"
  "${MINGW_PACKAGE_PREFIX}-python-jsonschema"
  "${MINGW_PACKAGE_PREFIX}-python-mako"
  "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
  "${MINGW_PACKAGE_PREFIX}-python-pygccxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyaml" 
  "${MINGW_PACKAGE_PREFIX}-python-pyzmq"
  "${MINGW_PACKAGE_PREFIX}-python-scipy"
  "${MINGW_PACKAGE_PREFIX}-python-qtpy"
  "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
  "${MINGW_PACKAGE_PREFIX}-python-pyqtgraph"
  "${MINGW_PACKAGE_PREFIX}-python-lxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyopengl"
  "${MINGW_PACKAGE_PREFIX}-qt5-base"
  "${MINGW_PACKAGE_PREFIX}-angleproject"
  "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
  "${MINGW_PACKAGE_PREFIX}-SDL"
  "${MINGW_PACKAGE_PREFIX}-soapysdr"
  "${MINGW_PACKAGE_PREFIX}-portaudio"
  "${MINGW_PACKAGE_PREFIX}-libsndfile"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-fmt"
  "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cppzmq"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python-packaging"
             "${MINGW_PACKAGE_PREFIX}-python-pip")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-setuptools"
              "${MINGW_PACKAGE_PREFIX}-python-pytest")
optdepends=("${MINGW_PACKAGE_PREFIX}-soapyrtlsdr: install to use RTL-SDR devices with gnuradio")
options=('!strip')
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/gnuradio/gnuradio/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz.asc"
        0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch
        gnuradio-blocks-and-examples-path.hook.in
        gnuradio-blocks-and-examples-path.script.in
        LICENSE.txt)
validpgpkeys=(
  'B90DDFAC56989BF62262EB812987C77CBB8ED9B2'  # GNU Radio Project (Admin) <admin@gnuradio.org>
  'D74F9F146E7F755783583158B343B2BA293E5174'  # Marcus Müller (GNU Radio Maintainer) <mmueller@gnuradio.org>
  '723EC3A2B90533C6B93DFBC8ED797743F7951435'  # GNU Radio (Software Signing Key) <info@gnuradio.org>
)
sha256sums=('fe78ad9f74c8ebf93d5c8ad6fa2c13236af330f3c67149d91a0647b3dc6f3958'
            'SKIP'
            'aa9c79f6ab923c566f57d90117fa7e82549c26230538ffb3a2b1c0246fc31c19'
            'b2f014a69b32afcb207e4d2e8e163fc04968594d7d4c3184b9ea5c8cf2a29329'
            'caa9a6cc253d508abcd01545f26b46df0d708d24f69b7dc59183d631872721ed'
            '86dc4bc79c9fa4d5dc3ae5558441d5bb8b8736403e70997cf9ae8f671ab5d0ca')
 
prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Patch number 0001 is credited to Ryan Volz <ryan.volz@gmail.com> and licensed under the 
  # BSD-3-Clause license
  patch -Np1 -i "${srcdir}/0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # FIXME remove -DENABLE_CTRLPORT_THRIFT=OFF when issue 7390 is fixed
  # https://github.com/gnuradio/gnuradio/issues/7390

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBoost_ATOMIC_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_atomic-mt.dll" \
      -DBoost_CHRONO_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_chrono-mt.dll" \
      -DBoost_DATE_TIME_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_date_time-mt.dll" \
      -DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_program_options-mt.dll" \
      -DBoost_THREAD_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_thread-mt.dll" \
      -DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_unit_test_framework-mt.dll" \
      -DENABLE_CTRLPORT_THRIFT=OFF \
      -S "${_realname}-${pkgver}" \
      -DMATHJAX2_JS_PATH="${MINGW_PREFIX}/share/mathjax2" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  #copy all dlls to a directory
  if [ ! -d temp_lib ]; then
    mkdir temp_lib
    find . -name "*.dll" ! -path '*temp_lib*' -exec cp {} temp_lib \;
  fi

  #add a call to os.add_dll_directory() to load python dlls
  python_dll_prefix=`cygpath.exe -m -a .`
  python_dll_suffix="/gnuradio-runtime/python/gnuradio/gr/bindings"

  #run the sed regex
  find . -name "*_test.bat" -exec sed.exe -i 's|^\(.*python3.exe\)|\1 -c "import os; os.add_dll_directory('\'${python_dll_prefix}${python_dll_suffix}\'');"|g' {} \;

  #run tests with dll directory added to the path
  PATH=$PWD/temp_lib:$PATH \
    "${MINGW_PREFIX}"/bin/ctest.exe --timeout 90 --output-on-failure || warning "Tests failed"
}

package() {

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  #install hook and script for setting global_blocks_path and examples_path in grc.conf
  hook_path="${srcdir}"/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.hook
  cp "${srcdir}/gnuradio-blocks-and-examples-path.hook.in" "${hook_path}"
  sed -s "s|@MINGW_PACKAGE_PREFIX@|${MINGW_PACKAGE_PREFIX}|g" -i "${hook_path}"
  install -Dt "$pkgdir/usr/share/libalpm/hooks" -m644 "${hook_path}"

  script_path="${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.script";
  cp "${srcdir}/gnuradio-blocks-and-examples-path.script.in" "${script_path}"
  sed -s "s|@MINGW_PREFIX@|${MINGW_PREFIX}|g" -i "${script_path}"
  install -Dt "$pkgdir/usr/share/libalpm/scripts" -m755 "${script_path}"
 
  #install licenses
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
